/*
 *
 * Конфигурация MyBGBilling.
 * Не забудьте создать резервную копию перед правкой.
 *
 */


// Параметры подключения к BGBillingServer.
// ЛК является пользователем биллинга, общается с ним также, как BGBillingClient
bgbilling {

    // URL доступа к BGBilling
    url = 'http://127.0.0.1:8080/bgbilling/executer'

    // Логин
    user = 'customer'
    // Пароль
    password = '123456'
}
// END bgbilling


// Параметры аутентификации абонента
authentication {

    // Кол-во ошибок аутентификации, после которого будет отображаться captcha для этого логина
    captchaLoginErrorCount = 5

    // Кол-во ошибок аутентификации, после которого будет отображаться captcha для хоста
    captchaHostErrorCount = 20

    // Кол-во ошибок аутентификации, после которых будут заблокированы попытки этого хоста
    blockHostErrorCount = 30
    
    // Режимы аутентификации для входа в ЛК
    modes = [

		// аутентификация по номеру договора
    	authenticationMode {
 			mode = 'contract'
    	}
    	
    	/*
    	// аутентификация по логину Inet
    	, authenticationMode {
     		mode = 'login'
     		module = 'inet'
     		moduleId = 1
     	}
     	*/
     	
    	/*
    	// аутентификация по IP-адресу
    	, authenticationMode {
     		mode = 'ip'
     		module = 'inet'
     		moduleId = 1
     		// ограниченный доступ
     		role = 'unauthCustomer'
     		//filter = { contract -> contractInGroup( contract, [1, 2, 3, 4, 20] ) }
     	}
     	*/
	]
}
// END authentication


// Параметры для SMTP, чтобы ЛК мог отправлять письма
mail {

	smtp {
		host = ''
	}
	
	from {
		email = ''
		name = 'MyBGBilling'
	}
}


context {

    // Базовый адрес сервера (через который абоненты получают доступ к ЛК). По умолчанию используется значение из запроса
    //baseUrl = 'https://my.provider.ru'

    // Идентификатор хоста по HTTP-заголовку, например, 'X-Real-IP'. По умолчанию используется IP-адрес хоста
    hostHttpRequestHeader = null
    
    // Код валюты для форматирования денежных значений RUB, BYN, UZS
    currencyCode = 'RUB'
    
	// Стартовая страница
    startPage = 'kernel/news'

	// Используемая theme, смотри resources/theme
    theme = 'yeti'
}


// Параметры содержимого страниц
content {

	login {
	  // Показывать ссылки для загрузки приложения "Мой провайдер" из сторов на странице авторизации
	  showAppIcon = false
	}

	kernel {
	
	//Согласие с обработкой персональных данных
	//ID параметра типа флаг
	//confirmParamId=<ID>;
	//Текст соглашения
	//confirmText="<someString>";
	
		// название контрагента, отображаемое на странице
		customerTitle = { contract, contractParameterMap ->
		
			// ID параметров договоров названия физ. лиц (для customerTitle)
			def individualCustomerTitleParamIds = [0, 0, 0, 0, 0];
			// ID параметров договоров названия юр. лиц (для customerTitle)
			def corporationCustomerParamIds = [0, 0, 0, 0, 0];
	
			def paramIds = contract.personType == 1 ? corporationCustomerParamIds : individualCustomerTitleParamIds;
	
			String result = contractParameterMap.values().stream()
				.filter{ v -> paramIds.contains( v.entitySpecAttrId ) && notBlankString( v.toString() ) }
				.findFirst()
				.map{ v -> v.toString() }
				.orElse( null );
			
			// можно отобразить и просто комментарий договора
			//if( result == null ) {
			//	result = contract.comment;
			//}
			
			return result;
		}
		
		// группировка субдоговоров (для меню)
		subContractGroup = { subContractList ->
		
			subContractList
			.stream()
			.sorted({ a,b -> a.title.compareTo(b.title) })
			.collect( Collectors.groupingBy{ contract ->

				/*
				// можно группировать субдоговора по группам договоров
				if( contractInGroup( contract, [1, 2, 3, 4, 20] ) ) {
					return "contract.sub.group.01.internet";
				}else if( contractInGroup( contract, [5, 6, 7, 8, 9] ) ) {
					return "contract.sub.group.02.phone";
				} else {
					return "contract.sub.group.99.other";
				}
				*/

				// если всем возвращать пустую строку - то группировки не будет
				return "";
			})
			.entrySet()
			.stream()
			.sorted({ a,b -> a.key.compareTo(b.key) })
			.collect( Collectors.toList() );
		}
		
		
		//balance.xhtml
		// отображение расшифровки наработки по услугам
		//balance.contractAccountList = true
	
		// limit.xhtml
		// возможность изменения лимита договора
		//limit.limitChange = true
		//limit.limitChange = { isCustomer() }
		//limit.limitChange = { contract -> (contract.balanceMode == (byte)1) && contractInGroup( contract, [1, 2, 3, 4, 20] ) && isCustomer() }
		limit.limitChange = { contract -> (contract.balanceMode == (byte)1) && isCustomer() }
	
		// status.xhtml
		// возможность изменения статуса договора
		//status.statusChange = { contract -> return contractInGroup( contract, [1, 2, 3, 4, 20] ) && isCustomer(); }
		//status.statusChange = { contract -> contractInGroup( contract, [1, 2, 3, 4, 20] ) && isCustomer() }
		status.statusChange = { isCustomer() }
		
		// cards.xhtml
		//cards.filter = { contract, contractCard -> contractCard.id in ['card_test.xsl'] }
		
		// отображение параметров договора
		parameters = { isCustomer() }
	}
	// END kernel
	
	
	bill {
		// возможность создания счета
		//billCreate = { contract -> return contractInGroup( contract, [1, 2, 3, 4, 20] ); }
		//billCreate = { contract -> contractInGroup( contract, [1, 2, 3, 4, 20] ) }
		billCreate = { isCustomer() };
		
		invoices = { contract -> contract.getPersonType() == 1 }
		
		invoicesTitle = 'bill.invoices' // 'bill.acts'
	}
	
	helpdesk {
		
		// отображение выбора дополнительного префикса заголовка
		newTopic.titlePrefix = false
		// название префикса
		newTopic.titlePrefixTitle = 'Продукт'
		newTopic.titlePrefixMessage = 'Выберите продукт...'
		// список префиксов для выбора
		newTopic.titlePrefixItems = [ ['[6.2]','BGBilling 6.2'], ['[6.1]','BGBilling 6.1'], ['[6.0]','BGBilling 6.0'],
								['[5.2]','BGBilling 5.2'], ['[5.1]','BGBilling 5.1'], ['[5.0]','BGBilling 5.0'],
			 					['[4.6]','BGBilling 4.6'], ['[CRM]','BGCRM'] ]
	
		// режим оповещения по email
		communication.email = true
		// режим оповещения по телефону
		communication.phone = false
		// режим оповещения по смс
		communication.sms = false
		// режим оповещения по telegram
		communication.telegram = true
	}
    //Настройки тарифных опций
    //сворачивать режимы активации тарифных опций
    //tariff_option.activationCollapse = true
    //Фильтр тарифных опций
    /*tariff_option.activationFilter = [
                              someitem( title: 'Группа1', regexp: '.*турб.*|.*Турб.*' ),
                              someitem( title: 'Группа2', regexp: '^CerberCrypt.*' )]
    */
}
// END content
