(function($) {


$.fn.popover.Constructor.prototype.getTitle = function () {
    var title
    var $e = this.$element
    var o  = this.options
    
    title = (typeof o.title == 'function' ? o.title.call($e[0]) : o.title)

    if(title == null) {
    	return '';
    }
    
    title = $e.attr('data-original-title') || title

    //title =  $e.data('tip') || $e.attr('placeholder')  || $e.attr('data-original-title') || (typeof o.title == 'function' ? o.title.call($e[0]) : o.title)

    return title
};


$.fn.bindWithDelay = function( type, data, fn, timeout, throttle ) {

    if ( $.isFunction( data ) ) {
        throttle = timeout;
        timeout = fn;
        fn = data;
        data = undefined;
    }

    // Allow delayed function to be removed with fn in unbind function
    fn.guid = fn.guid || ($.guid && $.guid++);

    // Bind each separately so that each element has its own delay
    return this.each(function() {

        var wait = null;

        function cb() {
            var e = $.extend(true, { }, arguments[0]);
            var ctx = this;
            var throttler = function() {
                wait = null;
                fn.apply(ctx, [e]);
            };

            if (!throttle) { clearTimeout(wait); wait = null; }
            if (!wait) { wait = setTimeout(throttler, timeout); }
        }

        cb.guid = fn.guid;

        $(this).bind(type, data, cb);
    });
};

})(jQuery);



jsf.ajax.addOnEvent(function(data) {
    if (data.status == "success") {
        fixViewState(data.responseXML);
    }
});

function handleDisableButton(data) {
    if (data.source == null || data.source.type != "submit") {
        return;
    }

    switch (data.status) {
        case "begin":
            data.source.disabled = true;
            break;
        case "complete":
            data.source.disabled = false;
            break;
    }    
}

jsf.ajax.addOnEvent(handleDisableButton);

function fixViewState(responseXML) {
    var viewState = getViewState(responseXML);

    if (viewState) {
        for (var i = 0; i < document.forms.length; i++) {
            var form = document.forms[i];

            if (form.method == "post" && form.className.indexOf("transientForm")<0) {
                if (!hasViewState(form)) {
                    createViewState(form, viewState);
                }
            }
            else { // PrimeFaces also adds them to GET forms!
                removeViewState(form);
            }
        }
    }
}

function getViewState(responseXML) {
    var updates = responseXML.getElementsByTagName("update");

    for (var i = 0; i < updates.length; i++) {
        var update = updates[i];

        if (update.getAttribute("id").match(/^([\w]+:)?javax\.faces\.ViewState(:[0-9]+)?$/)) {
            return update.firstChild.nodeValue;
        }
    }

    return null;
}

function hasViewState(form) {
    for (var i = 0; i < form.elements.length; i++) {
        if (form.elements[i].name == "javax.faces.ViewState") {
            return true;
        }
    }

    return false;
}

function createViewState(form, viewState) {
    var hidden;

    try {
        hidden = document.createElement("<input name='javax.faces.ViewState'>"); // IE6-8.
    } catch(e) {
        hidden = document.createElement("input");
        hidden.setAttribute("name", "javax.faces.ViewState");
    }

    hidden.setAttribute("type", "hidden");
    hidden.setAttribute("value", viewState);
    hidden.setAttribute("autocomplete", "off");
    form.appendChild(hidden);
}

function removeViewState(form) {
    for (var i = 0; i < form.elements.length; i++) {
        var element = form.elements[i];
        if (element.name == "javax.faces.ViewState") {
            element.parentNode.removeChild(element);
        }
    }
}

//jQuery.fx.interval = 39;

/*
 * ***************************************
 * BEGIN partial page update
 */
if (!window["busystatus"]) {
	var busystatus = {};
}

var updateTargetMap = {};
var updateScrollMap = {};
var noScrollMap = {};

busystatus.onStatusChange = function onStatusChange(data) {
    var status = data.status; // Can be "begin", "complete" or "success".
    
    if(data.source==null) {
    	return;
    }

    var id = (data.source.id+"");
    
    var menu = id.indexOf("sidebarMenuForm:") == 0;

    switch (status) {
        case "begin": // Before the ajax request is sent.
        	busystatus.onStatusBegin( data, id, menu );
            break;

        case "complete": // After the ajax response is arrived.
        	document.body.style.cursor = 'auto';
            break;

        case "success": // After update of HTML DOM based on ajax response..
        	busystatus.onStatusSuccess( data, id, menu );
            break;
    }
};

busystatus.onStatusBegin = function onStatusBegin(data, id, menu) {

	var source = document.getElementById(id);
	
	if(data.source.form) {
		if(data.source.nodeName.toUpperCase()==="INPUT" && (data.source.type=="button"||data.source.type=="submit")) {
			$(data.source.form).trigger("ajaxSubmit");
		} else {
			$(data.source.form).trigger("ajax");
		}
	}

	var target = source != null ? source.getAttribute("update-target") : null;
	var scroll = source != null ? source.getAttribute("update-scroll") : null;

	updateTargetMap[id] = target;
	updateScrollMap[id] = scroll;

	if (target != "none") {
		target = busystatus.getTarget(id, menu, target);
	}
	
	var update = true;

	if (target == "none") {
		update = false;
	} else if ($(source).hasClass('noupdate')) {
		update = false;
	}

	if (target != "none") {
		document.body.style.cursor = 'wait';
	}
	
	if (menu && update) {
		$('html, body').animate({
			scrollTop : 0
		}, 320);
	}

	if (update) {
		$(target).fadeTo(60, 0.3);
	}
};


busystatus.onStatusSuccess = function onStatusSuccess(data, id, menu) {

	var source = document.getElementById(id);

	var target = source != null ? source.getAttribute("update-target") : updateTargetMap[id];
	var scroll = source != null ? source.getAttribute("update-scroll") : updateScrollMap[id];
	

	if (noScrollMap[id] == true) {
		delete noScrollMap[id];
		scroll = null;
	}
	
	if(target!="none")
	{
		target = busystatus.getTarget(id, menu, target);
	}

	if (scroll != null && scroll.length > 0) {

		if ((scroll * 1 > 0 || scroll == 'yes')) {
			scroll = true;
		} else {

			var scrollEl = document.getElementById(scroll);
			if (scrollEl != null) {
				scroll = scrollEl;
			} else {
				scroll = false;
			}
		}
	} else {
		scroll = false;
	}
	

	var update = true;

	if (target == "none") {
		update = false;
	} else if ($(source).hasClass('noupdate')) {
		update = false;
	}

	document.body.style.cursor = 'auto';
	
	// исключаем закрытие ошибок по автозапускаемым обновлениям
	var autoAction = true;
	
	if (source != null) {
		
		if( source.nodeName === undefined ) {
			autoAction = false;
		} else {
			var clazz = $(source).attr('class');
			if( clazz === undefined || (clazz.indexOf('autoruns')<0 && clazz.indexOf('timered')<0) ) {
				autoAction = false;
			}
		}
	}
	
	if( !autoAction ) {
		$("#messages").hide();
	}

	if (update) {

		$(target).fadeTo(0, 0.3).fadeTo(160, 1);

		if ($(target).offset() == null) {
			console.error("target " + target + " not found");
		} else {

			if (!menu) {

				/*if (scrollTo != null && scrollTo != '') {

					$('html, body').animate( 
									{
										scrollTop : $(document.getElementById(scrollTo)).offset().top - 10
									}, 130);
					
				} else */
				if (scroll == true) {

					$('html, body').animate({
						scrollTop : $(target).offset().top - 10
					}, 130);
				} else if (scroll != null && scroll != false) {

					$('html, body').animate({
						scrollTop : $(scroll).offset().top - 10
					}, 130);
				}

			}

		}
	}
	// $(id).add("#messages").fadeTo(0, 0.3).fadeTo(130, 1)

	var messagesContent = document.getElementById("messages-content");
	
	//layout.fixLayout();
	initWidgets( source, target );
	
	if (source != null && !autoAction && messagesContent != null && $(messagesContent).html().trim() != '') {
		// alert($(messagesContent).html());

		source = $(source);
		
		while(source!=null && !source.is(':visible')) {
			source = source.parent();
		}
		
		//source[0].title = '';

		var a = source.popover({
			title : null,
			container : 'body',
			content : function() {
				return $(messagesContent).html();
			},
			html : true,
			placement : 'top',
			trigger : 'focus'
		});

		source.on('hidden.bs.popover', function() {
			source.popover('destroy');
		});

		source.popover('show');
		
		$(document).one('click', function(e) {
			source.popover('destroy');
		});
		
	} else {

	}

	// $("#page-wrapper2").hide().animate({opacity:100});
};

busystatus.getTarget = function getTarget(id, menu, target) {
	
	if (menu)
	{
		target = "#page-wrapper"
	} 
	else if (target == null || target.length == 0) {

		var idx = id.indexOf("Button");

		if (idx < 0) {
			idx = id.indexOf("Form");
		}

		if (idx >= 0) {
			target = id.substring(0, idx);
			idx = target.lastIndexOf(":");
			if (idx >= 0) {
				target = target.substring(idx + 1, target.length);
			}

			target = "#" + target;
		} else {
			target = "#page-wrapper"
		}

	} else {

		target = document.getElementById(target);
	}
	
	return target;
}
 
jsf.ajax.addOnEvent(busystatus.onStatusChange);

/*
 * END partial page update
 * ***************************************
 */


historypop = false;
historyback = 0;

function menu( a, title ) {
	if(historypop) {
		return;
	}
	
	window.history.pushState( {id:a.id, title:title}, null );
}


/*
 * ***************************************
 * BEGIN layout
 */
function getCssParam(selector,p) {
	
	var result = null;

    for(var i=0; i<document.styleSheets.length; i++) {
    	var classes = document.styleSheets[i].rules || document.styleSheets[i].cssRules;
        for (var x = 0; x < classes.length; x++) {
            if (classes[x].selectorText == selector) {
            	var val = classes[x].style[p];
            	if(val!=null) {
            		result = val;
            	}
            }
        }
    }
    
    return result;
}

layout = new Object();

layout._isMobile = false; //initiate as false
//device detection
if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent) 
|| /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4))) {
	layout._isMobile = true;
}

layout.isMobile = function() { return layout._isMobile; };


layout._isActive = false;

$(window).on("blur focus", function(e) {
    var prevType = $(this).data("prevType");

    if (prevType != e.type) {   //  reduce double fire issues
        switch (e.type) {
            case "blur":
            	layout._isActive = false;
                break;
            case "focus":
            	layout._isActive = true;
                break;
        }
    }

    $(this).data("prevType", e.type);
});

layout.isActive = function() { return layout._isActive; };


layout.hardwareConcurrency = navigator.hardwareConcurrency !== undefined ? navigator.hardwareConcurrency : 0;

if(layout.isMobile()) {
	layout._cpuLevel = 0;
} else {
	layout._cpuLevel = layout.hardwareConcurrency>=4?2:(layout.hardwareConcurrency>=2)?1:0;
}

layout.cpuLevel = function() {  if(layout.hardwareConcurrency>=4) return 2; else if(layout.hardwareConcurrency>=2) return 1; else return 0; };

if(layout.isMobile()) {
	if(jQuery.fx.interval<39) {
		jQuery.fx.interval = 39;
	}
}

layout.isCompact = function() { return ((window.innerWidth > 0) ? window.innerWidth : screen.width) < 768; };

layout.fixScroll = function( animate ) {
	
	if(layout.isCompact()) {
		
		if( layout.sidebar.obj.css('margin-top') != '0px' )
			layout.sidebar.obj.css('margin-top', '0px' );
  		
		if( layout.sidebar.obj.css('padding-top') != '0px' )
			layout.sidebar.obj.css('padding-top', '0px' );
		return;
	}

	if(animate!=true) animate = false;
	
  	var padding = 180 - $(window).scrollTop();
	
  	if($(window).height()>768)
  	//if($(window).height()>(layout.sidebar.nav.obj.height()+40))
  	if(padding<20)padding=20;
  	
  	if( padding>=0 ) {
  		
  		if(animate) {
  			
  			layout.sidebar.obj.animate({
  				paddingTop : padding,
  				marginTop : 0
  			}, 100);
  			
  		} else {
  	  		layout.sidebar.obj.css('margin-top', '0px' );
  	  		layout.sidebar.obj.css('padding-top', padding + 'px' );
  		}
  	} else {
  		
  		if(animate) {
  			
  			layout.sidebar.obj.animate({
  				paddingTop : 0,
  				marginTop : padding
  			}, 100);
  			
  		} else {
  	  		layout.sidebar.obj.css('padding-top', '0px' );
  	  		layout.sidebar.obj.css('margin-top', padding + 'px' );
  		}
  	}
  	
  	if ( layout.sidebar.nav.offset != null ) {
	    if ($(window).scrollTop() > layout.sidebar.nav.offset.top) {
	  	  layout.sidebar.obj.addClass('fixed');
	    } else {
	  	  layout.sidebar.obj.removeClass('fixed');
	    }
  	}
}

layout.fixLayout = function() {
	
	if(layout.isCompact()) {

		if( layout.sidebar.obj.css('margin-top') != '0px' )
			layout.sidebar.obj.css('margin-top', '0px' );
  		
		if( layout.sidebar.obj.css('padding-top') != '0px' )
			layout.sidebar.obj.css('padding-top', '0px' );
		
	
		return;
	}
	

   
    //var sidebar = $('.sidebar');
    //var paddingTop = sidebar.css('padding-top');
    var navHeight = layout.sidebar.nav.obj.height();
    //alert(navHeight);
    //console.log( "aa " + navHeight + "  " +sidebarObj.paddingTop  );
    $("#page-wrapper").css("min-height", (navHeight+layout.sidebar.paddingTop+100) + "px");
}


layout.onResize = function() {
	
    if (layout.isCompact()) {
    	
    	//if(!$('div.navbar-collapse').hasClass('collapse'))
        $('div.navbar-collapse').addClass('collapse')
        
        //topOffset = 100; // 2-row-menu
        //return;
    } else {
        $('div.navbar-collapse').removeClass('collapse')
    }
	
	layout.fixLayout();

	layout.fixScroll();
	
	layout.dropup();
}


layout.dropup = function() {
	$(".dropdown-toggle").each(function(){ 
		var par=$(this).parents('.btn-group');
		var dropl=par.find('ul');
		var otop=$(this).offset().top+$(this).height()-$(window).scrollTop();
		var ulh=dropl.height();
		var obot=$(window).height()-$(this).height()-$(this).offset().top+$(window).scrollTop();
	
		if ((obot < ulh) && (otop > ulh)) {
			par.addClass('dropup');
		} else {
			par.removeClass('dropup');
		}
	});
} 

//$(window).load(dropup);
//$(window).bind('resize scroll touchstart touchmove mousewheel', dropup);
//$(window).bind('resize', dropup);
/*
 * END layout
 * ***************************************
 */

function lsTest(){
    var test = 'test';
    try {
        localStorage.setItem(test, test);
        localStorage.removeItem(test);
        return true;
    } catch(e) {
        return false;
    }
}


// инициализация параметров для маски ввода телефонного номера
var maskList = null;
var phoneMaskOpts = null;
	

function initWidgets(source,target) {
	
	/*if(source!=null)
	{
		var sideMenu = $('.nav.sidebar-menu');
		if(sideMenu.length>0) {
			sideMenu.metisMenu();
			sideMenu.css('visibility', 'visible');
		}
	}*/
	
	var sideMenu = $('.nav.sidebar-menu');
	if(sideMenu.length>0 && sideMenu.data( "sidebar-menu" )!=1) {
		
		sideMenu.data( "sidebar-menu", 1 );
		sideMenu.metisMenu();
		
		if(layout.cpuLevel()<2) {
			//sideMenu.show();
			sideMenu.css('visibility', 'visible');
		} else {
			//sideMenu.show();
			//sideMenu.css('opacity', '0');
			sideMenu.css('visibility', 'visible');
			//sideMenu.fadeTo( 300, 1 );
		}
	}
	
	$('[data-toggle="tooltip"]').tooltip();
	$('.dt-tooltip').tooltip();

	$('.input-daterange').datepicker({
		format : myLocale.dateFormat,
		weekStart : 1,
		todayBtn : "linked",
		language : myLocale.language,
		autoclose : true,
		todayHighlight : true
	});
	
	/*$('.input-date').datetimepicker({
		format: "DD.MM.YYYY",
		allowInputToggle: true,
		ignoreReadonly: true,
		showTodayButton: true,
		locale : myLocale.language,
		t: function () {
            this.date(moment());
            this.hide();
        }
	});*/
	
	$('.input-date').datepicker({
		format : myLocale.dateFormat,
		weekStart : 1,
		todayBtn : "linked",
		language : myLocale.language,
		autoclose : true,
		todayHighlight : true
	});
	
	/*$('.input-month').datetimepicker({
		format: "MMMM YYYY",
		allowInputToggle: true,
		ignoreReadonly: true,
		locale : myLocale.language
	});*/

	$('.input-month').datepicker({
		format : myLocale.monthFormat,
		weekStart : 1,
		startView : 1,
		minViewMode : 1,
		todayBtn : "linked",
		language : myLocale.language,
		autoclose : true
	});// .on('changeMonth', function(e){this.childNodes[0].ondblclick()});

	if (typeof $().datetimepicker === "function") { 

		$('.input-time').datetimepicker({
			format: "HH:mm",
			allowInputToggle: true,
			showClose: true,
			ignoreReadonly: true,
			locale : myLocale.language
		});
	}

	// fix 3 times onchange
	// var datePicker = $('.date-picker').datePicker().on('changeDate', function(ev) {
    //Functionality to be called whenever the date is changed
	//trigger select
	//});
	$('.input-date > input').each(function(index) {
		
		if(this.onchangeJSFSet != null || this.onchange==null) {
			return;
		}
		
		this.onchangeJSFSet = "";
		
		this.onchangeJSF = this.onchange;
		
		this.onchange = function(event) {

			if (this.lastValue != null && this.lastValue == this.value) {
				return;
			}

			this.lastValue = this.value;

			this.onchangeJSF(event);
		};
	});
	
	$('.input-daterange input').on('changeDate', function(ev) {
		//this.trigger( "select" );
		//alert(this.value)
		//this.onselect();
	});
	
	$('.input-daterange input').each(function(index) {
		
		if(this.onchangeJSFSet != null || this.onchange==null) {
			return;
		}
		
		this.onchangeJSFSet = "";
		
		this.onchangeJSF = this.onchange;

		this.onchange = function(event) {

			if (this.lastValue != null && this.lastValue == this.value) {
				return;
			}
			
			this.lastValue = this.value;

			this.onchangeJSF(event);
		};
	});
	
	$('input.input-date').each(function(index) {
		
		if(this.onchangeJSFSet != null || this.onchange==null) {
			return;
		}
		
		this.onchangeJSFSet = "";
		
		this.onchangeJSF = this.onchange;
		
		this.onchange = function(event) {

			if (this.lastValue != null && this.lastValue == this.value) {
				return;
			}

			this.lastValue = this.value;

			this.onchangeJSF(event);
		};
	});
	
	$('.confirm').each(function(index) {
		
		if(this.onclickJSF!==undefined) {
			return;
		}
		//console.log("NEW: " + this.nodeName);
		//$(this).css("border", "3px solid #000000");

		this.onclickJSF = this.onclick;
		this.confirmationShowing = false;
		
		var c = this;
		var cc = $(this);
		
		cc.confirmation( {
			
			singleton:true, 
			popout:true, 
			btnOkClass:"btn-primary btn-sm", 
			btnOkIcon:"glyphicon glyphicon-ok",		
			btnCancelClass:"btn-primary btn-sm",
			btnCancelIcon:"glyphicon glyphicon-remove", 
			btnOkLabel:"Да", 
			btnCancelLabel:"Отмена",
			title:"Вы уверены?", container: 'body',
			placement: "auto",
			onConfirm: function(e){
			       //e.preventDefault();
			        //e.stopPropagation();
			        //e.stopImmediatePropagation();
				
				//return false;
				},
			onCancel: function(){ cc.confirmation('hide'); if (cc.data('bs.confirmation').inState) cc.data('bs.confirmation').inState.click = false; cc.confirmationShowing = false; /*cc.click();*/ }
		} )
		.on('shown.bs.confirmation', function(){	
			
			this.confirmationShowing = true;
			
			$(document).trigger( 'shown.some.confirmation', [ c ] );
			
			var f = function(e) {
				
				var t = $(e.target);
				//alert(e.target.nodeName)
				if(e.target==c || t.attr('data-apply')=='confirmation') {

					c.onclickJSF(e);
					 
			        e.preventDefault();
			        e.stopPropagation();
			        e.stopImmediatePropagation();
	
			        return false;

				} else if(t.attr('data-dismiss')!='confirmation') {
					
					cc.confirmation('hide');
					//cc.popover('hide');
				
					if (cc.data('bs.confirmation').inState) cc.data('bs.confirmation').inState.click = false; 
					cc.confirmationShowing = false;
					//cc.click();
				}

				//$(document).off('click', f);
			};
			
			$(document).one('click', f);
		})
		
		$(document).on('shown.some.confirmation', function( e, confirmation ){	
			
			if(confirmation!=c && c.confirmationShowing) {
				cc.confirmation('hide');
				if (cc.data('bs.confirmation').inState) cc.data('bs.confirmation').inState.click = false;
				//cc.click();
			}
		})
		
		// b.confirmation('show');
		
		/*b.on('shown.bs.confirmation', function(){	
			$(document).on('click', function(e) {
				b.confirmation('hide');
			});
	    });*/


		this.onclick = function(event) {
			
			//alert(123)
			//alert(event.target.nodeName);
			//if(event.target.nodeName=='A') {
				//event.preventDefault();
				///event.stopPropagation();
				//.stopImmediatePropagation();	
			//}
		//alert(c.nodeName)
			//console.log(c.nodeName);
			//console.log(c.onclickJSF);
			if(c.onclickJSF!=null) {
			
				//c.onclickJSF(event);
				
				return false;
			}
			
			return false;
		};

		
		/*this.onclick = function(event) {

			if (!confirmation(event, event.target)) {
				return false;
			}

			this.onclickJSF(event);
			return false;
		};*/
	});
    
	
    $(document).on('change', '.btn-file :file', function() {
  	  var input = $(this),
  	      numFiles = input.get(0).files ? input.get(0).files.length : 1,
  	      label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
  	  input.trigger('fileselect', [numFiles, label]);
  	});


    $('.btn-file :file').on('fileselect', function(event, numFiles, label) {
        
        var input = $(this).parents('.input-group').find(':text'),
            log = numFiles > 1 ? numFiles + ' files selected' : label;
        
        if( input.length ) {
            input.val(log);
        } else {
            if( log ) alert(log);
        }
        
    });
    
	$('.collapse').on('shown.bs.collapse', function (e) {
		layout.fixLayout();
	})
	
	$('.autorun').each(function( index ) {
		  if(source!=this) {
			  $(this).removeClass('autorun');
			  $(this).addClass('autoruns');
			  noScrollMap[this.id]=true;
			  this.click();
		  }
	});
	
	$('.timer1m').each(function( index ) {
		  $(this).removeClass('timer1m');
		  $(this).addClass('timered');
		  var btn = this;
		  
		  var onfocus = false;

		  if( btn.timer1m === undefined ) {
		  
			  var f = function() {
				  
				  //alert(document.contains(btn))
				  if ( btn.parentNode ) {
					  if (layout.isActive()) {
						  btn.click(); 
					  	  onfocus = false;
					  } else if (!onfocus) {
						  $(window).one('focus', f);
						  onfocus = true;
					  }
				  } else {
					  clearInterval( tid );
				  }
			  };
			  
			  var tid = setInterval(f, 60000);

			  btn.timer1m = tid;
		  }
	});
	
	$('.timer2m').each(function( index ) {
		  $(this).removeClass('timer2m');
		  $(this).addClass('timered');
		  var btn = this;

		  if( btn.timer2m === undefined ) {
		  
			  var tid = setInterval(function() {
				  if ( btn.parentNode ) {
					  if (layout.isActive()) btn.click(); else $(window).one('focus', f);
				  } else {
					  clearInterval( tid );
				  }
			  }, 120000);

			  btn.timer2m = tid;
		  }
	});
	
	$('.timer3m').each(function( index ) {
		  $(this).removeClass('timer3m');
		  $(this).addClass('timered');
		  var btn = this;

		  if( btn.timer3m === undefined ) {
		  
			  var tid = setInterval(function() {
				  if ( btn.parentNode ) {
					  if (layout.isActive()) btn.click(); else $(window).one('focus', f);
				  } else {
					  clearInterval( tid );
				  }
			  }, 180000);

			  btn.timer3m = tid;
		  }
	});
	

	// input-phone 7(123)123-12-12
	// нужна проверка на длину, иначе зря тормозит
	var inputPhone = $('.input-phone');
	if(inputPhone.length>0) {
		
		if(phoneMaskOpts==null) {
			maskList = $.masksSort($.masksLoad("static/plugins/"+myLocale.phoneCodes), ['#'], /[0-9]|#/, "mask");
			phoneMaskOpts = {
			    inputmask: {
			        definitions: {
			            '#': {
			                validator: "[0-9]",
			                cardinality: 1
			            }
			        },
			        //clearIncomplete: true,
			        showMaskOnHover: false,
			        autoUnmask: true
			    },
			    match: /[0-9]/,
			    replace: '#',
			    list: maskList,
			    listKey: "mask",
			    onMaskChange: function(maskObj, completed) {
			        if (completed) {
			            var hint = maskObj.name_ru;
			            if (maskObj.desc_ru && maskObj.desc_ru != "") {
			                hint += " (" + maskObj.desc_ru + ")";
			            }
			        } else {
			        }
			        $(this).attr("placeholder", $(this).inputmask("getemptymask"));
			    }
			};
		}
		
		inputPhone.inputmasks(phoneMaskOpts);
	}
	
    //$('.input-phone').inputmasks(phoneMaskOpts);
	
	// fix cursor on focus
	$('.input-phone').focus( function(e) {
		this.click();
	});
	
	// attribute autofocus not working on ajax dom modification, so use class
	if("none" != target && !layout.isMobile()) {
		
		var autofocus = target!=null? $('.autofocus', target ) : $('.autofocus' );
		
		if(autofocus.length>0) {
			$(autofocus[0]).trigger('focus');
		}
	}
	
	$('.input-phone').focus( function(e) {
		this.click();
	});
	
	layout.dropup();
	
	//$('.store').sisyphus();
	console.log( "localStorage " + (lsTest()) );

	if(lsTest()) {
		$('.store').each(function( index ) {
			
			if( this.id === undefined || this.id == null 
					|| this.value === undefined || this.value!='') {
				return;
			}
			
			var value = localStorage.getItem( this.id + '.value' );
			if(value!=null) {
				console.log( "restore value for " + this.id );
				this.value = value;
			}
		});
		
		$('.store').bindWithDelay("keyup", function(e) {
			console.log( "store value for " + e.target.id );
			localStorage.setItem( e.target.id + '.value', e.target.value );
		}, 1000, false);
		
		/*$(document).on('submit','form.remember',function(){
			
		});*/

		$('.store').closest("form").on('ajaxSubmit',function(){
			
			var t = $(this);

			t.find('.store').each( function(){ 
				console.log( "clear store value for " + this.id );
				localStorage.removeItem( this.id + '.value' ) } )
			
			setTimeout(function() {
				
				
				t.find('.store').each( function(){ 
					console.log( "clear store value for " + this.id );
					localStorage.removeItem( this.id + '.value' ) } )
			
			}, 1500)
		});
	}
}






function confirm( e, b ) {
	
	collapse = ((this.window.innerWidth > 0) ? this.window.innerWidth : this.screen.width) < 768;
	
	if(!b.confirmationFlag) {
		b.confirmationFlag = true;
		b = $(b);
		b.confirmation( {singleton:true, 
			
			popout:true, 
			btnOkClass:"btn-primary btn-sm", 
			btnOkIcon:"glyphicon glyphicon-ok",		
			btnCancelClass:"btn-primary btn-sm",
			btnCancelIcon:"glyphicon glyphicon-remove", 
			btnOkLabel:"Да", 
			btnCancelLabel:"Отмена",
			title:"Вы уверены?"
			, container: 'body',
			//placement: collapse?'left' : 'top'
				placement: "auto"
				
		} );
		b.confirmation('show');
		
		b.on('shown.bs.confirmation', function(){	
			$(document).on('click', function(e) {
				b.confirmation('hide');
			});
	    });
		
		return false;
	}
	
	if(e.handleObj) {
		return true;
	}

	return false;
}


// payment.xhtml
function paymentTransactionBegin( e )
{
	if( e!=null && e.status!='success' ) {
		return;
	}
	
	var form = document.getElementById( 'paymentTransactionBeginForm' );
	if( form!=null ) {
		
		$('#paymentForm\\:doPayment2').prop('disabled', true).css('cursor', 'wait');
		$('#paymentForm').css('cursor', 'wait');
		//document.body.style.cursor = 'wait';
		
		form.submit();
	}
	else
	{
		window.history.forward();
	}
	
	return false;
}


// notifications.xhtml
function notificationMarkRead( e )
{
	updateBadges( e );
}


function updateBadges( e )
{
	if( e!=null && e.status!='success' ) {
		return;
	}

	$('.badgeUpdater').trigger('click')
}


function checkDateChange( e ) {
	alert(e);
}




$(function() {
	//window.history.replaceState('', '' , 'index.xhtml');
	
	window.history.replaceState('', '' , 'index.xhtml');
	//window.history.replaceState('', '' , '/my/');
	
	window.onpopstate = function(event) {

		historypop = true;
		
		if(event.state!=null) {
			var el = document.getElementById( event.state.id );
			if( el!=null ) {
				historyback = 0;
				el.click();
			} else if ( historyback < 2 ) {
				historyback++;
				history.back()
			}
		}
		
		//$(document.getElementById( event.state.id ).parentNode).addClass("active");
		historyback = 0;
		historypop = false;
	};
	
	/*$('.input-month2').datepicker({
		format : "dd.mm.yyyy",
		startView: 0,
	    minViewMode: 0,
		language : "ru",
	    autoclose: true,
	    todayHighlight: true
	});*/
	
	initWidgets( null, null );
	
	$('#sidebar').bind("click", function(e) {

		var id = e.target.id;

		if ('sidebar' == id) {
			$('html, body').animate({
				scrollTop : 0
			}, 130);
		}
	});
	
    if (layout.isCompact()) {
        $('div.navbar-collapse').addClass('collapse')
    } else {
        $('div.navbar-collapse').removeClass('collapse')
    }
	
    var sidebar = $('.sidebar');
    var sidebarNav = $('.sidebar-nav')
    
    var pageWrapper = $("#page-wrapper");
    
    //var paddingTop = $('.sidebar').css('padding-top');
    
    layout.pageWrapper = new Object();
    layout.pageWrapper.obj = $( $("#page-wrapper")[0] );
    
    layout.sidebar = new Object();
    layout.sidebar.obj = $( $('.sidebar')[0] );
    layout.sidebar.paddingTop = getCssParam('.sidebar', 'paddingTop');
    layout.sidebar.paddingTop = 1* (layout.sidebar.paddingTop.substring(0, layout.sidebar.paddingTop.length - 2 ));
    
    layout.sidebar.nav = new Object();
    layout.sidebar.nav.obj = $( $('.sidebar-nav')[0] );
    
    // скроллинг
    layout.sidebar.nav.offset = $('.sidebar').offset();

    $(window).bind('scroll', layout.fixScroll );
    
    // расширение меню
	$('.sidebar-nav').bind("click", function(e) {

		setTimeout(layout.fixLayout, 500);
		setTimeout(layout.fixLayout, 1500);
		setTimeout(layout.fixLayout, 2500);
		
		//setTimeout( function(){ layout.fixLayout(); layout.fixScroll(true);}, 500);
		//setTimeout( function(){ layout.fixLayout(); layout.fixScroll(false);}, 1000);
		//setTimeout( function(){ layout.fixLayout(); layout.fixScroll(true);}, 2500);
	});
	
    $(window).bind("load resize", layout.onResize);
    
    layout.onResize();
    
    layout.dropup();
});


function checkboxRow( row, e ) {
    if (e.target.type !== 'checkbox') {
        $(':checkbox', row).trigger('click');
    }
}