/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 * Слушатель, который перенаправляет на страницу логина (если не авторизован) при Ajax-запросе.
 * 
 * @author amir
 */

public class AjaxLoginListener
	implements PhaseListener
{
	private static final long serialVersionUID = 7287626828591606425L;

	@Override
	public PhaseId getPhaseId()
	{
		return PhaseId.RESTORE_VIEW;
	}

	@Override
	public void beforePhase( final PhaseEvent event )
	{}

	@Override
	public void afterPhase( final PhaseEvent event )
	{
		final FacesContext context = event.getFacesContext();
		final HttpServletRequest request = (HttpServletRequest)context.getExternalContext().getRequest();
		final String originalURL = (String)request.getAttribute( RequestDispatcher.FORWARD_REQUEST_URI );
		final String loginURL = request.getContextPath() + "/login.xhtml";

		if( originalURL != null
			&& loginURL.equals( request.getRequestURI() ) )
		{
			if( context.getPartialViewContext().isAjaxRequest() )
			{
				try
				{
					context.getExternalContext().redirect( loginURL );
					((HttpSession)context.getExternalContext().getSession( true )).invalidate();
					context.getExternalContext().getSession( true );
				}
				catch( IOException e )
				{
					throw new FacesException( e );
				}
			}
			else
			{
//				ExternalContext ec = context.getExternalContext();
//
//				ec.responseReset(); // Some JSF component library or some Filter might have set some headers in the buffer beforehand. We want to get rid of them, else it may collide.
//
//				try
//				{
//					context.getExternalContext().redirect( originalURL );
//				}
//				catch( IOException e )
//				{
//					throw new FacesException( e );
//				}
//				finally
//				{
//					context.responseComplete();
//				}
			}
		}
	}
}
