/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.bgsecure.common.bean.UserInfo;
import ru.bitel.bgbilling.kernel.directory.api.common.bean.Directory;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@SessionScoped
@BGInjection
public class CommonBean
	implements Serializable
{
	private static final long serialVersionUID = 7794832284422496970L;

	@BGInject(type = UserInfo.class, module = false)
	private Directory<UserInfo> userInfoDirectory;

	/**
	 * Получение пользователя по id
	 * 
	 * @param userId
	 * @return
	 * @throws BGException
	 */
	public String getUser( int userId )
		throws BGException
	{
		if( userId == 0 )
		{
			return "Сервер";
		}

		UserInfo user = userInfoDirectory.get( userId );
		if( user != null )
		{
			return user.getName();
		}

		return "";
	}
}
