/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common;

import java.util.Collection;

import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

import ru.bitel.mybgbilling.kernel.menu.MenuBean;

/**
 * Слушатель, который добавляет на обновление компоненты.
 *  
 * @author amir
 */
public class MyPhaseListener
    implements PhaseListener
{
    private static final long serialVersionUID = 4260659917165594007L;

    @Override
    public PhaseId getPhaseId()
    {
        return PhaseId.INVOKE_APPLICATION;
    }

    @Override
    public void beforePhase( PhaseEvent event )
    {}

    @Override
    public void afterPhase( PhaseEvent event )
    {
        final FacesContext context = FacesContext.getCurrentInstance();

        Collection<String> renderIds = FacesContext.getCurrentInstance().getPartialViewContext().getRenderIds();

        boolean badge = false;
        if( renderIds.size() == 1 )
        {
            for( String renderId : renderIds )
            {
                if( renderId.endsWith( "badge" ) )
                {
                    badge = true;
                    break;
                }
            }
        }

        if( !badge )
        {
            renderIds.add( "messages" );
            renderIds.add( "messages-content" );
            renderIds.add( "navbar-top-links-form:balance-dropdown" );

            // только если авторизован
            if( FacesContext.getCurrentInstance().getExternalContext().getUserPrincipal() != null )
            {
                final MenuBean menuBean = (MenuBean)context.getELContext().getELResolver().getValue( context.getELContext(), null, "menuBean" );
                renderIds.addAll( menuBean.getBadgesIds() );
            }
        }
    }
}
