/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
 */
package ru.bitel.mybgbilling.kernel.common;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.enterprise.event.Event;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.http.HttpServletRequest;

@Named
@SessionScoped
public class UrlHandler
    implements Serializable
{
	public static class UrlEvent
	{
		private final HttpServletRequest request;
		private boolean stop = false;

		public UrlEvent( HttpServletRequest request )
		{
			this.request = request;
		}

		public HttpServletRequest getRequest()
		{
			return request;
		}

		public boolean isStop()
		{
			return stop;
		}

		public void setStop( boolean stop )
		{
			this.stop = stop;
		}

	}

    private String previousViewId = null;

    @Inject
    Event<UrlEvent> event;

    public void handle()
    {
        FacesContext context = FacesContext.getCurrentInstance();
        HttpServletRequest request = (HttpServletRequest)context.getExternalContext().getRequest();

        UIViewRoot viewRoot = context.getViewRoot();
        String id = viewRoot.getViewId();
        if( previousViewId != null && (previousViewId.equals( id )) )
        {
            // reload event
            viewRoot.getViewMap().clear();
        }
        previousViewId = id;

        event.fire( new UrlEvent( request ) );
    }
}
