/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
 */
package ru.bitel.mybgbilling.kernel.common.converters;

import java.io.Serializable;
import java.time.DayOfWeek;
import java.time.Month;

import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.common.Utils;
import ru.bitel.mybgbilling.kernel.navigation.LocaleBean;

@Named
@SessionScoped
public class MonthNameConverter
    implements Converter, Serializable
{
    private static final long serialVersionUID = 2539677503676355954L;

    @Inject
    private LocaleBean localeBean;

    @Override
    public Object getAsObject( FacesContext context, UIComponent component, String value )
    {
        try
        {
            return localeBean.getDayOfWeekFormat()
                .parse( value, Month::from );
        }
        catch( Exception ex )
        {
        }

        int v = Utils.parseInt( value );
        if( v > 0 && v <= 7 )
        {
            return DayOfWeek.of( v );
        }

        return null;
    }

    @Override
    public String getAsString( FacesContext context, UIComponent component, Object value )
    {
        return format( (Month)value );
    }

    public String format( Month month )
    {
        return localeBean.getMonthNameFormat()
            .format( month );
    }
}
