/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.inject;

import java.util.List;

import javax.interceptor.InvocationContext;

import ru.bitel.mybgbilling.kernel.common.MySessionBean;
import ru.bitel.mybgbilling.kernel.navigation.NavigationBean;

public class InjectPlan
{
	private final List<InjectPlanField> fieldInjectionList;

	InjectPlan()
	{
		this.fieldInjectionList = null;
	}

	public InjectPlan( final List<InjectPlanField> fieldInjectionList )
	{
		this.fieldInjectionList = fieldInjectionList;
	}

	public void process( final MySessionBean wsClientBean, final NavigationBean navigationBean, final InvocationContext ctx, final Object o )
		throws IllegalArgumentException, IllegalAccessException
	{
		for( int i = 0, size = fieldInjectionList.size(); i < size; i++ )
		{
			final InjectPlanField field = fieldInjectionList.get( i );
			field.process( wsClientBean, navigationBean, ctx, o );
		}
	}

	public void cleanup( final MySessionBean wsClientBean, final NavigationBean navigationBean, final InvocationContext ctx, final Object o )
		throws IllegalArgumentException, IllegalAccessException
	{
		for( int i = 0, size = fieldInjectionList.size(); i < size; i++ )
		{
			final InjectPlanField field = fieldInjectionList.get( i );
			field.cleanup( wsClientBean, navigationBean, ctx, o );
		}
	}
}
