/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
 */
package ru.bitel.mybgbilling.kernel.common.scope;

import javax.enterprise.event.Observes;
import javax.enterprise.inject.spi.AfterBeanDiscovery;
import javax.enterprise.inject.spi.Extension;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SessionModuleScopeExtension
    implements Extension
{
    private static final Logger logger = LogManager.getLogger();

    private SessionModuleScopeContext context;

    public SessionModuleScopeContext getContext()
    {
        return context;
    }

    private ViewModuleScopeContext viewContext;

    public ViewModuleScopeContext getViewContext()
    {
        return viewContext;
    }

    void afterBeanDiscovery( @Observes AfterBeanDiscovery abd )
    {
        logger.info( "afterBeanDiscovery" );

        context = new SessionModuleScopeContext();
        abd.addContext( context );

        viewContext = new ViewModuleScopeContext();
        abd.addContext( viewContext );
    }
}
