/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.utils;

import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.format.FormatStyle;
import java.util.Calendar;
import java.util.Date;

import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.inject.Named;

@Named
@SessionScoped
//@FacesConverter(value = "seriesPeriodConverter")
public class SeriesPeriodConverter
	implements Converter, Serializable
{
	private static final long serialVersionUID = 5079719502771744696L;
	
	private final DateFormat dateFormat = DateFormat.getDateInstance( DateFormat.MEDIUM );
	private final DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofLocalizedDate( FormatStyle.MEDIUM );
	private final DateFormat hourFormat = new SimpleDateFormat( "HH" );
	private final Calendar utilCalendar = Calendar.getInstance();
	
	private final DateTimeFormatter dateFormatter = DateTimeFormatter.ofLocalizedDate( FormatStyle.MEDIUM );
	private final DateTimeFormatter hourFormatter = DateTimeFormatter.ofPattern( "HH" );

	@Override
	public Object getAsObject( FacesContext context, UIComponent component,
							   String value )
	{
		return null;
	}

	@Override
	public String getAsString( FacesContext context, UIComponent component,
							   Object value )
	{
		String result = null;

		if( value instanceof Date )
		{
			utilCalendar.setTime( (Date)value );

			if( utilCalendar.get( Calendar.HOUR_OF_DAY ) == 0 )
			{
				return dateFormat.format( utilCalendar.getTime() );
			}
			else
			{
				return hourFormat.format( utilCalendar.getTime() );
			}
		}
		else if( value instanceof Calendar )
		{
			Calendar calendar = (Calendar)value;

			if( calendar.get( Calendar.HOUR_OF_DAY ) == 0 )
			{
				return dateFormat.format( calendar.getTime() );
			}
			else
			{
				return hourFormat.format( calendar.getTime() );
			}
		}
		else if( value instanceof LocalDate )
		{
			LocalDate localDate = (LocalDate)value;

			return dateTimeFormatter.format( localDate );
		}
		else if( value instanceof LocalDateTime )
		{
			LocalDateTime localDateTime = (LocalDateTime)value;

			if( localDateTime.getHour() == 0 )
			{
				return dateFormatter.format( localDateTime );
			}
			else
			{
				return hourFormatter.format( localDateTime );
			}
		}

		return result;
	}
}
