/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.utils;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.mybgbilling.kernel.navigation.LocaleBean;

@Named
@SessionScoped
public class ShortCurrencyConverter
	implements Converter, Serializable
{
	private static final long serialVersionUID = 7676496448185084869L;

	@Inject
	private LocaleBean localeBean;

	@Override
	public String getAsString( FacesContext context, UIComponent component, Object value )
	{
		return localeBean.formatShortCurrency( value );
	}

	@Override
	public Object getAsObject( FacesContext context, UIComponent component, String value )
	{
		return localeBean.parseCurrency( value );
	}
}
