/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.utils;

import java.util.ArrayList;
import java.util.List;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import ru.bitel.bgbilling.common.BGException;

@Named
@RequestScoped
public class Xml
{
	private XPath xpath = XPathFactory.newInstance().newXPath();

	public Iterable<Element> elements( NodeList nodeList )
	{
		if( nodeList == null )
		{
			return null;
		}

		List<Element> result = new ArrayList<>( nodeList.getLength() );

		for( int i = 0; i < nodeList.getLength(); i++ )
		{
			Node n = nodeList.item( i );
			if( n instanceof Element )
			{
				result.add( (Element)n );
			}
		}

		return result;
	}

	public String select( Object item, String expression )
		throws BGException
	{
		if( item == null )
		{
			return null;
		}

		try
		{
			return xpath.evaluate( expression, item );
		}
		catch( XPathExpressionException e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}

	public Iterable<Element> selectElements( Object item, String expression )
		throws BGException
	{
		if( item == null )
		{
			return null;
		}

		try
		{
			NodeList nodeList = (NodeList)xpath.evaluate( expression, item, XPathConstants.NODESET );
			return elements( nodeList );
		}
		catch( XPathExpressionException e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}

	public Object selectElement( Object item, String expression )
		throws BGException
	{
		if( item == null )
		{
			return null;
		}

		try
		{
			return (Element)xpath.evaluate( expression, item, XPathConstants.NODE );
		}
		catch( Exception e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}
}
