/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.utils;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.common.XMLUtils;

public class XmlUtils
{

	public static Iterable<Element> elements( NodeList nodeList )
	{
		return XMLUtils.elements( nodeList );
	}

	public static String select( Object item, String expression )
		throws BGException
	{
		try
		{
			XPath xpath = XPathFactory.newInstance().newXPath();
			return xpath.evaluate( expression, item );
		}
		catch( XPathExpressionException e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}

	public static Iterable<Element> selectElements( Object item, String expression )
		throws BGException
	{
		try
		{
			XPath xpath = XPathFactory.newInstance().newXPath();
			NodeList nodeList = (NodeList)xpath.evaluate( expression, item, XPathConstants.NODESET );
			return XMLUtils.elements( nodeList );
		}
		catch( XPathExpressionException e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}

	public static Object selectElement( Object item, String expression )
		throws BGException
	{
		try
		{
			XPath xpath = XPathFactory.newInstance().newXPath();
			return (Element)xpath.evaluate( expression, item, XPathConstants.NODE );
		}
		catch( Exception e )
		{
			throw new BGException( e.getMessage(), e );
		}
	}
}
