/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.common.utils;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.inject.Named;

import ru.bitel.common.Utils;

@Named
@SessionScoped
//@FacesConverter(value = "zeroConverter")
public class ZeroConverter
	implements Converter, Serializable
{
	private static final long serialVersionUID = -4476115939239103521L;

	@Override
	public Object getAsObject( FacesContext context, UIComponent component, String value )
	{
		return Utils.parseLong( value, 0 );
	}

	@Override
	public String getAsString( FacesContext context, UIComponent component, Object value )
	{
		final Number number = ((Number)value);
		if( number == null || number.longValue() == 0 )
		{
			return "";
		}
		else
		{
			return number.toString();
		}
	}
}
