/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.contract;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.common.Utils;
import ru.bitel.mybgbilling.kernel.common.UrlHandler.UrlEvent;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.menu.MenuBean;
import ru.bitel.mybgbilling.kernel.navigation.NavigationBean;

@Named
@RequestScoped
@BGInjection
public class KernelUrlHandler
{
	@Inject
	private NavigationBean navigationBean;

	@Inject
	private MenuBean menuBean;

	public void handle( @Observes UrlEvent e )
		throws BGException
	{
		if( e.isStop() )
		{
			return;
		}

		String page = e.getRequest().getParameter( "page" );
		if( Utils.isBlankString( page ) || !page.startsWith( "kernel/" ) )
		{
			return;
		}

		/*switch( page )
		{
			case "kernel/balance":
			case "kernel/additionalActions":
				break;
		
			default:
				break;
		}*/
		
		if( "kernel/payment".equals( page ) )
		{
			if( menuBean.checkContainsPage( "kernel/balance" ) )
			{
				e.setStop( true );
				navigationBean.setPage( page );
			}
		}
		else if( menuBean.checkContainsPage( page ) )
		{
			e.setStop( true );
			navigationBean.setPage( page );
		}
	}
}
