/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.contract;

import java.io.Serializable;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.directory.api.common.bean.Directory;
import ru.bitel.bgbilling.kernel.module.common.bean.Service;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@SessionScoped
@BGInjection
public class ServiceBean
	extends AbstractBean
	implements Serializable
{
	private static final Logger logger = LogManager.getLogger();

    @BGInject( type = Service.class, module = false )
	private Directory<Service> serviceDir;

	private Map<Integer, List<Service>> serviceMap;

	@Override
	protected void init()
		throws BGException
	{}

	public List<Service> getServiceList()
		throws BGException
	{
		return serviceDir.list();
	}

	public Service getService( int id )
		throws BGException
	{
		return serviceDir.get( id );
	}

	public List<Service> getServiceList( int moduleId )
		throws BGException
	{
		if( serviceMap == null )
		{
			//.filter( s-> s.getModuleId()==moduleId )
			serviceMap = getServiceList().stream().collect( Collectors.groupingBy( Service::getModuleId ) );
		}

		return serviceMap.get( moduleId );
	}
}
