/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.contract;

import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@SessionScoped
@BGInjection
public class TariffOptionActivateBean
	extends AbstractBean
{
	@Inject
	private TariffOptionBean tariffOptionBean;
	
	private int tariffOptionId;
	private int tariffOptionActivateModeId;
	private boolean payWithBonuses;

	public int getTariffOptionId()
	{
		return tariffOptionId;
	}

	public void setTariffOptionId( int tariffOptionId )
	{
		this.tariffOptionId = tariffOptionId;
	}

	public int getTariffOptionActivateModeId()
	{
		return tariffOptionActivateModeId;
	}

	public void setTariffOptionActivateModeId( int tariffOptionActivateModeId )
	{
		this.tariffOptionActivateModeId = tariffOptionActivateModeId;
	}

	public boolean isPayWithBonuses()
    {
        return payWithBonuses;
    }

    public void setPayWithBonuses( boolean payWithBonuses )
    {
        this.payWithBonuses = payWithBonuses;
    }

    public void activate()
		throws BGException
	{
		step = 1;
	}

	public void apply()
		throws BGException
	{
		if( step != 1 )
		{
			step = 0;
			return;
		}
		
		tariffOptionBean.activate( tariffOptionId, tariffOptionActivateModeId, payWithBonuses );

		step = 0;
	}
}
