/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.directory;

import java.io.Serializable;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Priority;
import javax.enterprise.context.Dependent;
import javax.inject.Inject;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ru.bitel.mybgbilling.kernel.common.MySessionBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.navigation.NavigationBean;

@Interceptor
@Priority(Interceptor.Priority.APPLICATION)
@BGInjection
@Dependent
public class DirectoryInjectInterceptor
	implements Serializable
{
	private static final Logger logger = LogManager.getLogger();

	@Inject
	private MySessionBean customerBean;

	@Inject
	private NavigationBean navigationBean;

	@Inject
	private DirectoryInjectManager directoryInjectManager;

	@PostConstruct
	void initialize( InvocationContext ctx )
		throws Exception
	{
		logger.debug( "initialize " + ctx.getTarget() );

		// ctx.getContextData().put( "moduleId", navigationBean.getModuleId() );

		directoryInjectManager.process( customerBean, navigationBean, ctx, ctx.getTarget() );

		ctx.proceed();
	}

	@PreDestroy
	void cleanup( InvocationContext ctx )
		throws Exception
	{
		logger.debug( "cleanup" );

		ctx.proceed();
	}
}
