/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.menu;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.List;

import javax.el.ValueExpression;
import javax.xml.bind.JAXB;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "menu")
public class MenuItem
	implements Cloneable
{
	private String page;
	private String subPage;
	private int moduleId;
	private String module;
	private String title;
	private String icon;
	
	private boolean show = true;
	
	private String badge;
	transient ValueExpression badgeExpression;
	private String badgeUpdate;
	transient ValueExpression badgeUpdateExpression;

	private List<MenuItem> children;

	@XmlAttribute
	public String getPage()
	{
		return page;
	}

	public void setPage( String page )
	{
		this.page = page;
	}
	
	@XmlAttribute
	public String getSubPage()
	{
		return subPage;
	}

	public void setSubPage( String subPage )
	{
		this.subPage = subPage;
	}

	@XmlAttribute
	public int getModuleId()
	{
		return moduleId;
	}

	public void setModuleId( int moduleId )
	{
		this.moduleId = moduleId;
	}

	@XmlAttribute
	public String getModule()
	{
		return module;
	}

	public void setModule( String module )
	{
		this.module = module;
	}

	@XmlAttribute
	public String getTitle()
	{
		return title;
	}

	public void setTitle( String title )
	{
		this.title = title;
	}

	@XmlAttribute
	public String getIcon()
	{
		return icon;
	}

	public void setIcon( String icon )
	{
		this.icon = icon;
	}

	@XmlAttribute
	public String getBadge()
	{
		return badge;
	}

	public void setBadge( String badge )
	{
		this.badge = badge;
	}

	@XmlAttribute
	public String getBadgeUpdate()
	{
		return badgeUpdate;
	}

	public void setBadgeUpdate( String badgeUpdate )
	{
		this.badgeUpdate = badgeUpdate;
	}

	public boolean isShow()
	{
		return show;
	}

	public void setShow( boolean show )
	{
		this.show = show;
	}

	@XmlElements(@XmlElement(type = MenuItem.class, name = "menu"))
	public List<MenuItem> getChildren()
	{
		return children;
	}

	public void setChildren( List<MenuItem> children )
	{
		this.children = children;
	}

	public static void main( String[] args )
	{
		MenuItem item = new MenuItem();
		item.setPage( "asdasd" );
		item.setModuleId( 0 );

		item.setChildren( new ArrayList<MenuItem>() );

		for( int i = 0; i < 5; i++ )
		{
			MenuItem item2 = new MenuItem();
			item2.setPage( "asdasd" );
			item2.setModuleId( i );

			item.getChildren().add( item2 );
		}

		ByteArrayOutputStream baos = new ByteArrayOutputStream();

		JAXB.marshal( item, System.out );

	}

	public MenuItem clone( final int moduleId )
	{
		MenuItem result;

		try
		{
			result = (MenuItem)super.clone();
			result.setModuleId( moduleId );

			if( this.children != null )
			{
				final List<MenuItem> children = new ArrayList<>( this.children.size() );

				for( MenuItem item : this.children )
				{
					children.add( item.clone( moduleId ) );
				}

				result.setChildren( children );
			}
		}
		catch( CloneNotSupportedException e )
		{
			throw new RuntimeException( e );
		}

		return result;
	}
}
