/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.payment;

import java.io.Serializable;
import java.util.List;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

import groovy.util.ConfigObject;

@XmlRootElement(name = "paymentConfig")
public class PaymentConfig
    implements Serializable
{
//    @Deprecated
//    public static final Set<String> PAYMENT_MODULES = new HashSet<String>( Arrays.asList( "agr", "assist", "alfabank", "bvcom", "mobimoney",
//        "mtsbank", "paymaster", "paylinks", "payture", "qiwi", "rbkmoney", "rfiec", "psb", "vepay", "pscb", "robokassa", "sberbank", 
//        "webmoney", "yoomoney", "yamoney", "payonline", "uniteller" ) );

	@XmlRootElement(name = "provider")
	public static class PaymentProvider
	{
		private String id;
		private String module;
		private int moduleId;
		private String title;
		private String image;
		
		private ConfigObject config;

		@XmlAttribute
		public String getId()
		{
			return id;
		}

		public void setId( String id )
		{
			this.id = id;
		}

		@XmlAttribute
		public String getModule()
		{
			return module;
		}

		public void setModule( String module )
		{
			this.module = module;
		}

		@XmlAttribute
		public int getModuleId()
		{
			return moduleId;
		}

		public void setModuleId( int moduleId )
		{
			this.moduleId = moduleId;
		}

		@XmlAttribute
		public String getTitle()
		{
			return title;
		}

		public void setTitle( String title )
		{
			this.title = title;
		}

		public String getImage()
		{
			return image;
		}

		public void setImage( String image )
		{
			this.image = image;
		}

		public ConfigObject getConfig()
		{
			return config;
		}

		public void setConfig( ConfigObject config )
		{
			this.config = config;
		}
	}

	/**
	 * У одного провайдера (платежной системы) может быть несколько режимов платежа назначенных через конфиг.
	 * По умолчанию же оперируем провайдерами.
	 */
	@XmlRootElement(name = "payment")
	public static class PaymentItem
	{
		private String title;
		private String image;
		private String providerId;
		private String type;
		
		private ConfigObject config;

		@XmlAttribute
		public String getTitle()
		{
			return title;
		}

		public void setTitle( String title )
		{
			this.title = title;
		}

		@XmlAttribute
		public String getImage()
		{
			return image;
		}

		public void setImage( String image )
		{
			this.image = image;
		}

		@XmlAttribute
		public String getProviderId()
		{
			return providerId;
		}

		public void setProviderId( String providerId )
		{
			this.providerId = providerId;
		}

		@XmlAttribute
		public String getType()
		{
			return type;
		}

		public void setType( String type )
		{
			this.type = type;
		}
		
		public ConfigObject getConfig()
		{
			return config;
		}

		public void setConfig( ConfigObject config )
		{
			this.config = config;
		}
	}

	private boolean replaceProviders;
	private boolean showCard;
	
	private boolean needReceiptContacts = true;

	private List<PaymentProvider> providers;

	private List<PaymentItem> payments;

	@XmlElementWrapper(name = "providers")
	@XmlElement(name = "provider")
	public List<PaymentProvider> getProviders()
	{
		return providers;
	}

	public void setProviders( List<PaymentProvider> providerList )
	{
		this.providers = providerList;
	}

	@XmlElementWrapper(name = "payments")
	@XmlElement(name = "payment")
	public List<PaymentItem> getPayments()
	{
		return payments;
	}

	public void setPayments( List<PaymentItem> paymentItemList )
	{
		this.payments = paymentItemList;
	}

	@XmlAttribute
	public boolean isReplaceProviders()
	{
		return replaceProviders;
	}

	public void setReplaceProviders( boolean replaceProviders )
	{
		this.replaceProviders = replaceProviders;
	}

	@XmlAttribute
	public boolean isShowCard()
	{
		return showCard;
	}

	public void setShowCard( boolean showCard )
	{
		this.showCard = showCard;
	}

	public boolean isNeedReceiptContacts()
	{
		return needReceiptContacts;
	}

	public void setNeedReceiptContacts( boolean receiptContacts )
	{
		this.needReceiptContacts = receiptContacts;
	}
}
