/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.realm;

import java.io.IOException;
import java.io.Serializable;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractService;
import ru.bitel.common.Utils;
import ru.bitel.mybgbilling.kernel.common.Configuration;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.ws.CustomerBean;
import ru.bitel.oss.kernel.entity.common.bean.EntityAttr;
import ru.bitel.oss.kernel.entity.common.bean.EntityAttrBoolean;
import ru.bitel.oss.kernel.entity.common.bean.EntitySpecAttrType;

@Named
@SessionScoped
@BGInjection
public class ConfirmBean
    implements Serializable
{
    private static final long serialVersionUID = -2421257459318323205L;
    private static final Logger logger = LogManager.getLogger();

    private boolean confirm = false;
    @BGInject(module = false)
    private ContractService contractService;
    @Inject
    private Configuration configuration;
    @Inject
    protected CustomerBean customerBean;

    @PostConstruct
    protected void init()
    {
        logger.info( "ConfirmBean - init" );
    }

    @PreDestroy
    private void destroy()
    {
    }

    public void confirm()
        throws IOException,
        BGException
    {
        if ( !confirm )
        {
            return;
        }
        //сохраняем
        Object obj = configuration.get( "content.kernel.confirmParamId" );
        if ( obj == null )
        {
            return;
        }
        int pid = Utils.parseInt( obj.toString(), -1 );
        if ( pid < 0 )
        {
            return;
        }
        EntityAttr param = contractService.contractParameterGet( customerBean.getContractId(), pid );
        if ( param == null )
        {
            param = EntityAttr.newInstance( 3, customerBean.getContractId(), pid );// boolean
        }
        if ( !(param instanceof EntityAttrBoolean) )
        {
            throw new BGException( "Неверный тип параметра для content.kernel.confirmParamId = " + pid );
        }
        EntityAttrBoolean newParam = (EntityAttrBoolean)param;
        newParam.setValue( true );
        contractService.contractParameterUpdate( customerBean.getContractId(), newParam );
        FacesContext context = FacesContext.getCurrentInstance();
        ExternalContext ec = context.getExternalContext();
        ec.redirect( "index.xhtml" );
    }

    public boolean isConfirm()
    {
        return confirm;
    }

    public void setConfirm( boolean confirm )
    {
        this.confirm = confirm;
    }
}
