package ru.bitel.mybgbilling.kernel.realm;

import java.security.Principal;

import javax.security.auth.login.FailedLoginException;

public class MyFailedLoginException
    extends FailedLoginException
{
    private final Principal identity;
    private final int contractId;

    public MyFailedLoginException( Principal identity, int contractId, String msg )
    {
        super( msg );

        this.identity = identity;
        this.contractId = contractId;
    }

    public MyFailedLoginException( Principal identity, int contractId, String msg, Throwable cause )
    {
        super( msg );

        if ( cause != null )
        {
            initCause( cause );
        }

        this.identity = identity;
        this.contractId = contractId;
    }

    public Principal getIdentity()
    {
        return identity;
    }

    public int getContractId()
    {
        return contractId;
    }
}
