/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.realm;

import java.io.File;
import java.io.FileInputStream;
import java.security.Principal;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.AccountNotFoundException;
import javax.security.auth.login.CredentialException;
import javax.security.auth.login.FailedLoginException;
import javax.security.auth.login.LoginException;
import javax.servlet.http.HttpServletRequest;
import javax.xml.ws.Holder;

import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
//import org.jboss.security.SimpleGroup;
//import org.jboss.security.SimplePrincipal;

import groovy.util.ConfigObject;
import ru.bitel.bgbilling.kernel.contract.api.common.bean.Contract;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractService;
import ru.bitel.common.groovy.GroovyBeanBuilder;
import ru.bitel.common.model.Page;
import ru.bitel.mybgbilling.kernel.ws.Pool;
import ru.bitel.mybgbilling.kernel.ws.WSClient;

public class WildflyLoginModule
//	extends org.jboss.security.auth.spi.UsernamePasswordLoginModule
{
	private static final Logger logger = LogManager.getLogger();

	public WildflyLoginModule()
	{

		logger.info( "MyRealm LoginModule - Construction" );
	}

	@SuppressWarnings({ "unchecked" })
	public void initialize( Subject subject, CallbackHandler callbackHandler, Map<String, ?> sharedState, Map<String, ?> options )
	{
//		String name = this.getClass().getSimpleName();
//		if( name.equals( "WildflyLoginModule" ) )
//		{
//			name = "MyBGBilling";
//		}
//		else
//		{
//			name = name.substring( 0, name.length() - "LoginModule".length() );
//		}
//
//		String fileName = name + ".war/WEB-INF/mybgbilling-conf.groovy";

//		this.connection = CONNECTION_MAP.compute( fileName, ( k, v ) -> {
//
//
//		} );

		// We could read options passed via <module-option> in standalone.xml if there were any here
		// For an example see http://docs.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5/html/Security_Guide/sect-Custom_LoginModule_Example.html

		// We could also f.ex. lookup a data source in JNDI
		// For an example see http://www.docjar.com/html/api/org/jboss/security/auth/spi/DatabaseServerLoginModule.java.html
//		super.initialize( subject, callbackHandler, sharedState, options );
	}

	//@Override
	protected Principal createIdentity( String username )
		throws Exception
	{
		logger.log( Level.INFO, String.format( "WildflyLoginModule: authenticating user '%s'", username ) );

//		ContractService contractService = connection.pool.take();
//		try
//		{
			Holder<Page> pageHolder = new Holder<>();
			pageHolder.value = new Page( 1, 1 );

			// XXX: на самом деле в JAAS всё не так должно быть, ну да ладно
			boolean unauth = false;

			if( username.startsWith( "[unauthCustomer]" ) )
			{
				unauth = true;
				username = username.substring( "[unauthCustomer]".length() );
			}
			
//            String regexUsername = username.replaceAll( "\\[", "\\\\[" ).replaceAll( "\\]", "\\\\]" );
//
//            List<Contract> contractList = contractService.contractList( "^" + regexUsername + "$", null, -1, 0L, null, true, false, true, pageHolder );
//
//			if( contractList != null )
//			{
//				for( Contract contract : contractList )
//				{
//					if( username.equalsIgnoreCase( contract.getTitle() ) )
//					{
//                        logger.info( "Contract found: id=" + contract.getId() + ", title=" + contract.getTitle() );
//
//						return new ContractPrincipal( contract );
//					}
//				}
//			}
//
//			logger.info( "Contract not found: " + username );
//
//			//throw new AccountNotFoundException( "Договор \"" + username + "\" - не найден." );
//			//throw new BGException( "Договор не найден." );
//			throw new AccountNotFoundException( "Договор не найден." );
//		}
		/*catch( BGException ex )
		{
			if( ex.getCause() instanceof SQLException && ex.getCause().getMessage().contains( "regex" ) )
			{
				throw new LoginException( "Указан некорректный номер договора." );
			}
		
			logger.log( Level.SEVERE, ex.getMessage(), ex );
		}*/
//		catch( AccountNotFoundException e )
//		{
//			throw e;
//		}
//		catch( Throwable e )
//		{
//			logger.log( Level.ERROR, e.getMessage(), e );
//
//			Throwable t = e;
//			while( t != null )
//			{
//				t = t.getCause();
//			}
//		}
//		finally
//		{
//			connection.pool.recycle( contractService );
//		}

		// Let's also pretend that we haven't got it in plain text but encrypted
		// (the encryption being very simple, namely capitalization)

		//return null;

		logger.info( "Contract not found: " + username );

		//throw new AccountNotFoundException( "Договор \"" + username + "\" - не найден." );
		//throw new BGException( "Договор не найден." );
		throw new FailedLoginException( "Договор не найден." );

		// TODO Auto-generated method stub
		//return super.createIdentity( arg0 );
	}

//	@Override
	protected String getUsersPassword()
		throws LoginException
	{
//		return ((ContractPrincipal)getIdentity()).getUser().getPassword();
		return null;
	}

	/**
	* (optional) Override if you want to change how the password are compared or
	* if you need to perform some conversion on them.
	*/
//	@Override
	protected boolean validatePassword( String inputPassword, String expectedPassword )
	{
//		if( super.validatePassword( inputPassword, expectedPassword ) )
//		{
			return true;
//		}
//		else
//		{
//			this.setValidateError( new CredentialException( "Неверный пароль" ) );
//			return false;
//		}
	}

	/**
	 * (required) The groups of the user, there must be at least one group called
	 * "Roles" (though it likely can be empty) containing the roles the user has.
	 */
//	@Override
//	protected Group[] getRoleSets()
//		throws LoginException
//	{
//		SimpleGroup group = new SimpleGroup( "Roles" );
//		try
//		{
//			final Principal principal = super.getIdentity();
//
//			if( principal instanceof ContractPrincipal )
//			{
//				if( !((ContractPrincipal)principal).unauth )
//				{
//					group.addMember( new SimplePrincipal( "customer" ) );
//				}
//				else
//				{
//					group.addMember( new SimplePrincipal( "unauthCustomer" ) );
//				}
//			}
//			else
//			{
//				group.addMember( new SimplePrincipal( "unauthCustomer" ) );
//			}
//		}
//		catch( Exception e )
//		{
//			throw new LoginException( "Failed to create group member for " + group );
//		}
//		return new Group[] { group };
//	}

//	@Override
	public boolean login()
		throws LoginException
	{
//		try
//		{
//			return super.login();
//		}
//		catch( FailedLoginException ex )
//		{
//			if( getIdentity() != null )
//			{
//				throw new MyFailedLoginException( getIdentity(), 0, ex.getMessage(), ex );
//			}
//
//			throw ex;
//		}
	    return true;
	}
}
