package ru.bitel.mybgbilling.modules.card;

import java.io.Serializable;
import java.util.Date;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.modules.card.common.service.CardService;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.MySessionBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.contract.BalanceBean;
import ru.bitel.mybgbilling.kernel.payment.PaymentBean;
import ru.bitel.mybgbilling.kernel.payment.PaymentConfig.PaymentProvider;

@Named
@ViewScoped
@BGInjection
public class CardBean
    extends AbstractBean
    implements Serializable
{
    @Inject
    private PaymentBean paymentBean;
    
    @Inject
    private BalanceBean balanceBean;

    @Inject
    private MySessionBean mySessionBean;

    private String number;
    private String pin;

    public String getNumber()
    {
        return number;
    }

    public void setNumber( String cardNumber )
    {
        this.number = cardNumber;
    }

    public String getPin()
    {
        return pin;
    }

    public void setPin( String cardPin )
    {
        this.pin = cardPin;
    }

    @Override
    protected void init()
    {
    }

    public void activate()
        throws BGException
    {
        // текущий выбранный PaymentProvider
        // в отличие от ModulePaymentBean у CardBean moduleId будет 0
        PaymentProvider paymentProvider = paymentBean.getPaymentProvider();

        CardService cardService = mySessionBean.getPort( CardService.class, paymentProvider.getModuleId() );

        cardService.cardActivateForPayment( getContractId(), number, pin );
        
        navigationBean.setPage( "kernel/balance", 0 );

        balanceBean.setMonth( new Date() );
        balanceBean.populate();
    }
}
