/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.modules.cerbercrypt;

import java.time.LocalDate;

import javax.enterprise.context.ConversationScoped;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.mybgbilling.kernel.common.AbstractConversationBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@ConversationScoped
@BGInjection
public class CerbercryptActivateBean
	extends AbstractConversationBean
{
	private static final long serialVersionUID = 7673890048667747106L;

	@Inject
	private CerbercryptBean cerbercryptBean;

	private LocalDate dateFrom;
	private LocalDate dateTo;

	private int packetId;

	public LocalDate getDateFrom()
	{
		return dateFrom;
	}

	public void setDateFrom( LocalDate dateFrom )
	{
		this.dateFrom = dateFrom;
	}

	public LocalDate getDateTo()
	{
		return dateTo;
	}

	public void setDateTo( LocalDate dateTo )
	{
		this.dateTo = dateTo;
	}

	public int getPacketId()
	{
		return packetId;
	}

	public void setPacketId( int packetId )
	{
		this.packetId = packetId;
	}

	public void activate()
		throws BGException
	{
		if( conversation.isTransient() )
		{
			conversation.begin();
		}

		step = 1;
	}

	public void apply()
		throws BGException
	{
		if( step != 1 )
		{
			step = 0;
			return;
		}

		cerbercryptBean.activate( packetId, dateFrom );

		step = 0;
	}

	public void deactivate( int cardPacketId )
		throws BGException
	{
		LocalDate dateTo = this.dateTo;
		this.dateTo = null;
		
		cerbercryptBean.deactivate( cardPacketId, dateTo );
	}
}
