/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.modules.payment;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.common.BGIllegalAccessException;
import ru.bitel.bgbilling.common.BGIllegalArgumentException;
import ru.bitel.bgbilling.common.BGMessageException;
import ru.bitel.bgbilling.modules.agr.common.service.AGRService;
import ru.bitel.common.model.MapHolder;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.common.scope.SessionModuleScoped;

import javax.inject.Named;
import javax.xml.ws.Holder;
import java.io.Serializable;
import java.math.BigDecimal;

@Named("agrPaymentBean")
@SessionModuleScoped
@BGInjection
public class AGRPaymentBean
	extends AbstractPaymentBean
	implements PaymentServiceProviderBean, Serializable
{
	@BGInject
	private AGRService agrService;

	public boolean isNeedPhone()
	{
		return true;
	}

	@Override
	public void beginTransaction( int contractId, BigDecimal amount, Holder<String> url, Holder<String> mode, Holder<MapHolder<String, String>> params )
		throws BGException
	{
		agrService.beginTransaction( contractId, amount, url, mode, params );
	}

	@Override
	public void endTransaction( int contractId, BigDecimal amount, Holder<String> url, Holder<String> mode, Holder<MapHolder<String, String>> params )
		throws BGException, BGMessageException, BGIllegalArgumentException, BGIllegalAccessException
	{
		agrService.endTransaction( contractId, amount, url, mode, params );
	}
}
