/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.modules.payment;

import java.io.Serializable;
import java.util.List;

import javax.inject.Inject;

import ru.bitel.bgbilling.common.bean.BGAbstractTransaction;
import ru.bitel.bgbilling.kernel.contract.autopayment.common.service.ContractAutopaymentService;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.payment.PaymentConfig;
import ru.bitel.mybgbilling.kernel.payment.PaymentConfigProducer.PaymentConfigProduce;

public abstract class AbstractPaymentBean
	extends AbstractBean
	implements PaymentServiceProviderBean, Serializable
{
	@Inject
	@PaymentConfigProduce
	private PaymentConfig paymentConfig;

	@BGInject
	private ContractAutopaymentService contractAutopaymentService;

	@Override
	public ContractAutopaymentService getContractAutopaymentService()
	{
		return contractAutopaymentService;
	}

	@Override
	public boolean isNeedReceiptContacts()
	{
		return paymentConfig.isNeedReceiptContacts();
	}
	
    public List<? extends BGAbstractTransaction> getRecentTransactions()
    {
        return null;
    }
}
