/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
 */
package ru.bitel.mybgbilling.modules.rentsoft;

import java.util.Random;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.modules.rentsoft.common.RentsoftService;
import ru.bitel.common.function.Async;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@RequestScoped
@BGInjection
public class RentsoftBean
    extends AbstractBean
{
    private static final long serialVersionUID = -2778597351229165472L;

    private static final Random random = new Random();

    @Inject
    private RentsoftUrlHandler urlHandler;

    @BGInject
    private RentsoftService rentsoftService;

    private final long rsId = Math.abs( random.nextLong() );

    private Async<String> source;

    public long getRsId()
    {
        return rsId;
    }

    @Override
    protected void init()
        throws BGException
    {
        super.init();

        String rsUri = urlHandler.getRsUri();

        source = Async.of( () -> rentsoftService.source( getContractId(), rsUri ) );
    }

    public String getSource()
        throws BGException
    {
        return source.get();
    }
}
