/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
 */
package ru.bitel.mybgbilling.modules.rentsoft;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.http.HttpServletRequest;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.mybgbilling.kernel.common.UrlHandler.UrlEvent;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.common.utils.Utils;
import ru.bitel.mybgbilling.kernel.menu.MenuBean;
import ru.bitel.mybgbilling.kernel.menu.MenuItem;
import ru.bitel.mybgbilling.kernel.navigation.NavigationBean;

@Named
@RequestScoped
@BGInjection
public class RentsoftUrlHandler
{
    @Inject
    private NavigationBean navigationBean;

    @Inject
    private MenuBean menuBean;

    private String rsUri;
    private String requestedQuery;

    public String getRequestedQuery()
    {
        return requestedQuery;
    }

    public String getRsUri()
    {
        return rsUri;
    }

    public void handle( @Observes UrlEvent e )
        throws BGException
    {
        if( e.isStop() )
        {
            return;
        }

        final HttpServletRequest request = e.getRequest();

        String rsUri = request.getParameter( "rs_uri" );
        if( rsUri == null )
        {
            return;
        }

        e.setStop( true );

        // ищем, есть ли в меню (разрешен ли абоненту) рентсофт, а также и id модуля
        MenuItem menuItem = menuBean.getMenuItemForPage( "modules/rentsoft/rentsoft" );
        if( menuItem == null )
        {
            return;
        }

        this.rsUri = rsUri;

        if( Utils.notBlankString( request.getQueryString() ) )
        {
            requestedQuery = request.getQueryString();
        }

        navigationBean.setPage( "modules/rentsoft/rentsoft", menuItem.getModuleId() );
    }
}
