package ru.bitel.mybgbilling.modules.softline;

import groovy.util.ConfigObject;
import ru.bitel.bgbilling.common.BGException;
import ru.bitel.common.groovy.GroovyBeanBuilder;

import javax.faces.context.ExternalContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Map;

/**
 * Для получения изображений продуктов с сервера биллинга
 */
@WebServlet(name = "SoftLineExecutor", urlPatterns = "/softlineexecutor/*")
public class ModuleExecutor
    extends HttpServlet
{
    @Override
    protected void doPost( HttpServletRequest req, HttpServletResponse resp )
        throws IOException
    {
        doGet( req, resp );
    }

    @Override
    protected void doGet( HttpServletRequest req, HttpServletResponse resp )
        throws IOException
    {
        resp.setContentType( "image/png" );

        HttpURLConnection connection = getURLConnection( req );
        byte[] response = getResponseByteArray( connection );
        resp.getOutputStream().write( response );
    }

    private HttpURLConnection getURLConnection( HttpServletRequest request )
    {
        try
        {
            //из конфигурационного файла вытаскиваем адрес до сервера биллинга и заменяем executer сервера биллинга на executer модуля
            ExternalContext externalContext = SoftLineBean.getExternalContext();
            GroovyBeanBuilder bb = new GroovyBeanBuilder();
            ConfigObject configObject = bb.load( externalContext.getResourceAsStream( "/WEB-INF/mybgbilling-conf.groovy" ), "mybgbilling-conf.groovy" );
            Map<Object, Object> configMap = configObject.flatten();
            String billingUrl = (String)configMap.get( "bgbilling.url" );

            URL url = new URL( billingUrl.replace( "executer", "softlineexecutor/?" + request.getQueryString() ) );
            HttpURLConnection connection = (HttpURLConnection)url.openConnection();
            connection.setRequestMethod( "GET" );

            return connection;
        }
        catch( IOException | BGException ignored ) { }

        return null;
    }

    private byte[] getResponseByteArray( HttpURLConnection connection )
        throws IOException
    {
        if( connection == null )
        {
            return new byte[]{};
        }

        InputStream inputStream = connection.getInputStream();
        if( inputStream != null )
        {
            return inputStream.readAllBytes();
        }

        return new byte[]{};
    }
}
