/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.modules.tv;

import javax.enterprise.context.ConversationScoped;
import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.mybgbilling.kernel.common.AbstractConversationBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@ConversationScoped
@BGInjection
public class TvProductActivateBean
	extends AbstractConversationBean
{
	private static final long serialVersionUID = 3548594604177407610L;

	@Inject
	private TvBean tvBean;

	private int productSpecId;

	private int productSpecActivationModeId;

	public int getProductSpecId()
	{
		return productSpecId;
	}

	public void setProductSpecId( int productSpecId )
	{
		this.productSpecId = productSpecId;
	}

	public int getProductSpecActivationModeId()
	{
		return productSpecActivationModeId;
	}

	public void setProductSpecActivationModeId( int productSpecActivationModeId )
	{
		this.productSpecActivationModeId = productSpecActivationModeId;
	}

	public void activate()
		throws BGException
	{
		if( conversation.isTransient() )
		{
			conversation.begin();
		}

		step = 1;
	}

	public void apply()
		throws BGException
	{
		if( step != 1 )
		{
			step = 0;
			return;
		}

		tvBean.activate( productSpecId, productSpecActivationModeId );

		step = 0;
	}
}
