package ru.bitel.mybgbilling.modules.voice;

import java.util.List;
import java.util.Set;
import java.util.function.Supplier;
import java.util.stream.Collectors;

import javax.inject.Inject;
import javax.inject.Named;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.directory.api.common.bean.Directory;
import ru.bitel.bgbilling.modules.voice.common.bean.VoiceAccount;
import ru.bitel.bgbilling.modules.voice.common.bean.VoiceAccountType;
import ru.bitel.bgbilling.modules.voice.common.service.VoiceAccountService;
import ru.bitel.common.model.Period;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.bitel.mybgbilling.kernel.common.scope.SessionModuleScoped;
import ru.bitel.mybgbilling.kernel.ws.CustomerBean;

import javax.inject.Inject;
import javax.inject.Named;
import java.util.Date;
import java.util.List;
import java.util.Set;
import java.util.function.Supplier;
import java.util.stream.Collectors;

@Named
@SessionModuleScoped
@BGInjection
public class VoiceAccountBean 
{
    @BGInject
    private VoiceAccountService accountService;
    
    private List<VoiceAccount> accountList;    
    
    @Inject
    private CustomerBean customerBean;
    
    //private int voiceAccountId;
    
    private Supplier<Set<Integer>> accountIds;
    
    
    private VoiceAccount account;
    
    @BGInject(type = VoiceAccountType.class)
    private Directory<VoiceAccountType> accountTypeDirectory;


    
    public List<VoiceAccount> getVoiceAccountList(Date dateFrom, Date dateTo)
        throws BGException
    {
        accountList = accountService.voiceAccountList( customerBean.getContractId(), 0, new Period( dateFrom, dateTo ) );
        return accountList;
    }

    
    public VoiceAccountType getVoiceAccountType( int id )
        throws BGException
    {
        return accountTypeDirectory.get( id );
    }    
    
    public VoiceAccount getVoiceAccount()
    {
        return account;
    }



    public Set<Integer> getAccountIds()
    {
        return accountIds != null ? accountIds.get() : null;
    }



    public void setAccountIds( Set<Integer> accountIds )
    {
        if( accountIds != null )
        {
            accountIds.retainAll( accountList.stream().map( a -> a.getId() ).collect( Collectors.toSet() ) );
        }

        this.accountIds = () -> accountIds;
    }
   
}
